/** @name LIBRARY: fwConfigurationDBSystemInformationDeprecated.ctl

Creation date: 2018-08-22

Purpose:
This library contains deprecated functions from fwConfigurationDBSystemInformation.ctl library, 
that may be eventually removed from component distribution. 

*/

/** fwConfigurationDBSystemInformation_getCurrentNavigationMode
  * @deprecated 2018-08-22
  */
int fwConfigurationDBSystemInformation_getCurrentNavigationMode(string &currentMode)
{
  FWDEPRECATED();
  
  return dpGet(FW_SYS_STAT_DB_NAV_DP + ".currentMode", currentMode); 
}

/** fwInstallationDB_getGroupComponentXml
  * @deprecated 2018-08-22
  */
int fwInstallationDB_getGroupComponentXml(string component, string version, string group, string &xml)
{
  FWDEPRECATED();
  
  int group_id, component_id;
  string sql;
  dyn_dyn_mixed aRecords;
  
  if(fwInstallationDB_isGroupRegistered(group, group_id) != 0){
    DebugN("ERROR: fwInstallationDB_getGroupComponentXml() - > Cannot access the DB.");
    return -1;
  }
  
  if(group_id == -1){
      DebugN("ERROR: fwInstallationDB_getGroupComponentXml() - > Group: " + group + " is not registered in DB.");
      return -1;      
  }
  
  if(fwInstallationDB_isComponentRegistered(component, version, component_id) != 0){
    DebugN("ERROR: fwInstallationDB_getGroupComponentXml() - > Cannot access the DB.");
    return -1;
  }
  
  if(component_id == -1){
      DebugN("ERROR: fwInstallationDB_getGroupComponentXml() - > Component: " + component + " v." + version + " is not registered in DB.");
      return -1;      
  }
  
  sql = "SELECT description_file FROM fw_sys_stat_comp_in_groups WHERE fw_component_id = " + component_id + 
        " AND group_id = " + group_id;
       
  if(g_fwInstallationSqlDebug)
    DebugN(sql);
  
  if(fwInstallationDB_executeDBQuery(sql, aRecords) != 0)
  {
    DebugN("ERROR: fwInstallationDB_getGroupComponentXml() - > Could not execute the following SQL query: " + sql);
    return -1;
  }    
  
  if(dynlen(aRecords))
    xml = (string) aRecords[1];
  
  return 0;
}

/** fwInstallationDB_getHostComponentGroups
  * @deprecated 2018-08-22
  */
int fwInstallationDB_getHostComponentGroups(string computer, dyn_string &groupNames)
{
  FWDEPRECATED();
  
  string sql;
  dyn_dyn_mixed aRecords;

  dynClear(aRecords);  
  dynClear(groupNames);  
  

  dyn_mixed var;
  var[1] = computer;
  var[2] = computer;
  
  sql = "select name " +
        "from fw_sys_stat_group_of_comp " +
        "where id in (select group_id " +
			 "from fw_sys_stat_project_groups " +
			 "where valid_until is null and " + 
			 	"project_id IN (select id from fw_sys_stat_pvss_project " +
			 	              "where VALID_UNTIL IS NULL " + 
			 	              	"AND (computer_id = (select id from fw_sys_stat_computer where hostname = :1 and valid_until is null) " +
			 	                					"or redu_computer_id = (select id from fw_sys_stat_computer where hostname = :2 and valid_until is null))))";
           
  if(g_fwInstallationSqlDebug)
      DebugN(sql);
  
//  if(fwInstallationDB_executeDBQuery(sql, aRecords) != 0)
  if(fwInstallationDB_executeQuery(sql, var, aRecords))
  {
      DebugN("ERROR: fwInstallation_getComponentGroups() -> Could not execute the following SQL query: " + sql);
      return -1;
  }  

  for(int i = 1; i <= dynlen(aRecords); i++) {          
     dynAppend(groupNames, aRecords[i][1]);
  }
  
  return 0;
}

/** fwInstallationDB_getProjectComponentGroups
  * @deprecated 2018-08-22
  */
int fwInstallationDB_getProjectComponentGroups(string project, string computer, dyn_string &groupNames)
{
  FWDEPRECATED();
  
  string sql;
  dyn_dyn_mixed aRecords;
  
  dynClear(aRecords);  
  dynClear(groupNames);  
  

  dyn_mixed var;
  var[1] = project;
  var[2] = computer;
  var[3] = computer;
  
  sql = "select name from fw_sys_stat_group_of_comp " + 
        "where id in (select group_id from fw_sys_stat_project_groups where valid_until is null and project_id = (select id from fw_sys_stat_pvss_project where project_name = :1 and " +
        "id in (select project_id from fw_sys_stat_pvss_project where VALID_UNTIL IS NULL AND (computer_id = " + 
        "(select id from fw_sys_stat_computer where hostname = :2 and valid_until is null) or redu_computer_id = (select id from fw_sys_stat_computer where hostname = :3 and valid_until is null)))))";
           
  if(g_fwInstallationSqlDebug)
      DebugN(sql);
  
//  if(fwInstallationDB_executeDBQuery(sql, aRecords) != 0)
  if(fwInstallationDB_executeQuery(sql, var, aRecords))
  {
      DebugN("ERROR: fwInstallation_getComponentGroups() -> Could not execute the following SQL query: " + sql);
      return -1;
  }  

  for(int i = 1; i <= dynlen(aRecords); i++) {          
     dynAppend(groupNames, aRecords[i][1]);
  }
  
  return 0;
}

/** fwInstallationDB_registerComponentInDefaultGroup
  * @deprecated 2018-08-22
  */
int fwInstallationDB_registerComponentInDefaultGroup(string componentName, string componentVersion, string descFile, int isSubComponent)
{
  FWDEPRECATED();
  
  string groupName = componentName + "_" + componentVersion;

  return fwInstallationDB_registerComponentInGroup(componentName, componentVersion, isSubComponent, desFile, groupName);
}
